package sam.machine.engine ; 

import java.util.* ; 
import sam.machine.lang.* ;

/**
  *  Cache of new facts, 
  *  used by active inference components.
  *  @version 4/4/2020 
   */
class Cache { 
   protected int leaf ;   // -1 none, otherwise index in facts.
   protected Vector<Functor> facts ; 

   protected Cache() { 
      this.leaf = -1 ; 
      this.facts = new Vector<Functor>()  ; 
   }

   protected void clear() { 
      this.leaf = -1 ; 
      this.facts.clear() ;
   }

   //Add fact to cache, record if leaf. 
   protected void add(Functor f) {
      //   now now leaf        goal         false
      if (this.leaf==-1 && (f.index==1 | f.index==2) )   
         this.leaf= facts.size() ; // where first leaf is *1
      this.facts.add(f) ;
   }

   /**
     *  Show facts generated ... 
     *       "[f1,f2,...]" 
      */
   public String toString() { 
      Iterator it = this.facts.iterator() ;
      StringBuffer bf = new StringBuffer() ;
      bf.append ("[") ;
      while (it.hasNext()) { 
         bf.append(it.next()) ; 
         if (it.hasNext()) bf.append(",") ;
      }
      bf.append("]") ;
      return bf.toString() ;
   }      
} 
/*  ENDNOTES
*1  Active component may finish (or not?) if becomes leaf,
    depends on other code.

*/
