// last CoCO
package sam.infer ; 

import java.util.concurrent.* ;
import sam.geolog.* ; 
import sam.util.* ; 
import java.util.* ; 
import java.awt.* ; 

/***  BranchManager */
public class BranchManager implements Callable<SearchResults> {  
   protected final int poolsize ; 
   protected final ExecutorService threadpool ; 
   protected final ConcurrentLinkedQueue<Branch> branchpool ;     
   protected final ConcurrentLinkedQueue<Future<SearchResults>> branchWork ;  
   ... more

   /***  Construct BranchManager.  */
   public BranchManager(Theory theory,int depth) { 
      this.poolsize = defaultPoolsize() ; 
      this.threadpool = Executors.newCachedThreadPool() ; 
      this.branchpool = new ConcurrentLinkedQueue<Branch>() ; 
      for (int i = 0 ; i < poolsize ; i ++) 
         branchpool.add(new Branch(this)) ; 
      this.branchWork = new ConcurrentLinkedQueue<Future<SearchResults>>() ;
      ... more
   } 

   /***  call Search for proof. @return -2= error, -1=overflow, 0=countermodel, 1=proof */
   public SearchResults call() { 
      Branch firstbranch = branchpool.remove() ;  
      branchWork.add(threadpool.submit(firstbranch)) ; 
      SearchResults sr = new SearchResults(-2,0,0,0) ; 
         ... more
      while (!branchWork.isEmpty()) { 
         try {
            sr = ((Future<SearchResults>)branchWork.remove()).get() ; 
            branchcount++ ; 
            factcount += sr.factcount ; 
            inferencecount += sr.inferencecount ; 
         } 
         catch(Exception xx) { 
            System.out.println(xx) ; 
         }
         if (sr.status < 1) 
            return new SearchResults(sr.status,factcount,inferencecount,branchcount) ; 
      }
      return new SearchResults(1,factcount,inferencecount,branchcount) ; // PROOF
   } 

   /*** Fetch a usable branch, from pool or make. */
   private synchronized Branch fetchBranch() { 
      if (!branchpool.isEmpty()) 
         return branchpool.remove() ;  
      else 
         return new Branch(this) ; 
   }

   /***  Spawn a new branch.  Complicated.*/
   public int spawn(Branch old,int fcs,Conjunction conj) { ...}

   /***  Shut down my threadpool after call() has returned. */
   public void shutdown() { 
      threadpool.shutdown() ; 
   }
   
   public synchronized int factCount() { 
      int ret = this.factcount++ ; 
      this.factcount++ ; 
      return ret ; 
   } 

   private int defaultPoolsize() { ... }

   /*** Unique skolem numbers across all branches. */
   public synchronized int skolem() { ... }

} // end BranchManager

